﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private fx As JFX
	Public jowe, jowv As JavaObject
	Public workspacesfolder As String
	Public textfilesfolder As String
	Public lblfolder As Label
	Private wvcode As WebView
	Private mnu1 As MenuBar
	Private spn1 As SplitPane
	Private pnleft As Pane
	Private tpnleft As TabPane
	Public pnright As Pane
	Private tpnright As TabPane
	Private panetab As Pane
	Private fchoose As FileChooser
	Private dirchoose As DirectoryChooser
	Public dialog As B4XDialog
	Private ftffoldername As B4XFloatTextField
	Private lbltitle As Label
	Public clvb4jitems As CustomListView
	Public clvb4aitems As CustomListView
	Public currfolder As String = ""
	Private hclass As htmlclass
	Public pathsmap As Map
	Public wvcodemap As Map
	Public wvsitemap As Map
	Private panetableft As Pane
	Private wvsite As WebView
	Private cbx1 As B4XComboBox
	Private btnshow As Button
	Private btnback As Button
	Private btnforward As Button
	Public extvb As List = Array As String(".bas",".b4a",".b4j")
	Public extweb As List = Array As String(".txt",".html",".css",".js",".json",".xml",".php",".sql")
	Public codeobjmap As Map
	Private cbx2 As B4XComboBox
	Private tfpath As TextField
	Private btnclose As Button
	Private btnsiteclose As Button
	Private btnsave As Button
End Sub
Public Sub Initialize
	B4XPages.GetManager.LogEvents = True
End Sub
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	B4XPages.SetTitle(Me,"tryityourself")
	fchoose.Initialize
	dirchoose.Initialize
	xui.SetDataFolder("tryityourself")
	File.MakeDir(xui.DefaultFolder,"workspaces")
	File.MakeDir(xui.DefaultFolder,"textfiles")
	workspacesfolder = File.DirData("tryityourself") & "\workspaces"
	textfilesfolder = File.DirData("tryityourself") & "\textfiles"
	dialog.Initialize(Root)
	hclass.Initialize
	pathsmap.Initialize
	wvcodemap.Initialize
	wvsitemap.Initialize
	codeobjmap.Initialize
	set_layout
	Dim jo As JavaObject = tpnright
	jo.RunMethod("setTabClosingPolicy", Array("ALL_TABS"))
	Dim ev As Object = jo.CreateEventFromUI("javafx.collections.ListChangeListener", "TabsListChanged", Null)
	jo.RunMethodJO("getTabs", Null).RunMethod("addListener", Array(ev))
	Dim jo As JavaObject = tpnleft
	jo.RunMethod("setTabClosingPolicy", Array("ALL_TABS"))
	Dim ev As Object = jo.CreateEventFromUI("javafx.collections.ListChangeListener", "LeftTabsListChanged", Null)
	jo.RunMethodJO("getTabs", Null).RunMethod("addListener", Array(ev))
	jowe.InitializeNewInstance("javafx.scene.web.WebEngine",Null)
End Sub
Private Sub B4XPage_Appear
	fill_cbx1
	fill_cbx2
End Sub
Private Sub B4XPage_Resize (Width As Int, Height As Int)
	If wvcode.IsInitialized Then
		reload_wvcode(tfpath.text.SubString(tfpath.text.LastIndexOf("\")+1))
	End If
End Sub
Private Sub set_layout
	spn1.LoadLayout("paneleft_layout")
	spn1.LoadLayout("paneright_layout")
	spn1.DividerPositions= Array As Double(0.50,0.50)
End Sub
Private Sub mnu1_Action
	Dim mitem As MenuItem = Sender
	Select mitem.Text
		Case "_Create"
			create_workspace_folders
		Case "_Open"
			open_workspace_folder
		Case "_Remove"
			remove_workspace_folder
		Case "_Webserver"
			show_localhost
		Case "_New"
			add_code_tabpage("New.txt","")
		Case "_Load"
			load_file("")
		Case "_Save"
			save_file
		Case "_Exit"
			ExitApplication
	End Select
End Sub
Private Sub show_localhost
	Dim j As HttpJob
	j.Initialize("",Me)
	j.PostString("http://localhost","")
	Wait For (j) JobDone(j As HttpJob)
	If j.Success Then
		add_website_tabpage("URL","","http://localhost")
	Else
		xui.MsgboxAsync("It seems that the webserver is not running.","webserver")
		Log(j.ErrorMessage)
	End If
	j.Release
End Sub
Private Sub open_workspace_folder
	dirchoose.InitialDirectory = workspacesfolder
	Dim folder As String = dirchoose.Show(B4XPages.GetNativeParent(B4XPages.MainPage))
	'Log(folder)
	If folder = "" Then Return
	get_workspace_files(folder)
	If File.Exists(folder,"index.html") Then 
		Dim strtxt As String = File.ReadString(folder, "index.html")
		add_website_tabpage("index.html",strtxt,folder)
	End If
	If File.Exists(folder,"index.php") Then
		Dim strtxt As String = File.ReadString(folder, "index.php")
		add_website_tabpage("index.php",strtxt,folder)
	End If
End Sub
Private Sub create_workspace_folders
	make_folder(workspacesfolder)
	B4XPage_Appear
End Sub
Private Sub create_index_file(sitefolder As String)
	'Log(sitefolder)
	If File.Exists(sitefolder,"index.html") Then Return
	Dim title As String = sitefolder.SubString(sitefolder.LastIndexOf("\")+1)
	Dim name As String = sitefolder.SubString(sitefolder.LastIndexOf("\")+1)
	Dim css As String = "file:///" & sitefolder & "\css\w3.css"
	Dim strtxt As String = $"
	<!DOCTYPE html>
	<html>
	<head>
	<link rel='stylesheet' href='${css}'>${CRLF}
	<title>${name}</title>
	</head>
	<body class='w3-container w3-margin w3-border'>
	<h1>${title}</h1>
	<p>This is the index page of this workspace.<p>
	<p>Add code to complete this workspace.</p>
	</body>
	</html>"$
	File.WriteString(sitefolder,"index.html",strtxt)
	B4XPage_Appear
End Sub
Private Sub load_indexfile(path As String)
	Dim filename As String = "index.html"
	If filename = "" Then Return
	Dim strtxt As String = File.ReadString(path, filename)
	add_code_tabpage(filename,strtxt)
	pathsmap.Put(filename,path)
	tfpath.text = " " & path & "\" & filename
	add_website_tabpage("index.html",strtxt,path)
End Sub
Private Sub make_folder(parent As String)
	Dim p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0, 0, 540dip, 120dip)
	p.LoadLayout("foldernamedialog_layout")
	dialog.PutAtTop = True
	dialog.BackgroundColor = xui.Color_LightGray
	ftffoldername.Text = ""
	lbltitle.Text = "Create workspace folder in " & parent
	Dim rs As ResumableSub =  dialog.ShowCustom(p, "OK", "", "CANCEL")
	Wait For (rs) Complete (Result As Int)
	If ftffoldername.text = "" Then Return
	If Result = xui.DialogResponse_Positive Then
		If File.Exists(parent,ftffoldername.Text) Then
			xui.MsgboxAsync("A workspace with this name already exists","Create workspace")
			Return
		End If
		File.MakeDir(parent,ftffoldername.Text)
		File.MakeDir(parent & "\" & ftffoldername.Text,"css")
		File.Copy(File.DirAssets,"w3.css",parent & "\" & ftffoldername.Text & "\css","w3.css")
		File.MakeDir(parent & "\" & ftffoldername.Text,"javascript")
	End If
	create_index_file(parent & "\" & ftffoldername.Text)
End Sub
Private Sub fill_cbx2
	Dim lst As List = File.ListFiles(workspacesfolder)
	'Log(lst)
	If lst.Size < 1 Then Return
	cbx2.SetItems(lst)
	cbx2.SelectedIndex = -1
End Sub
Private Sub cbx2_SelectedIndexChanged (Index As Int)
	If File.Exists(workspacesfolder & "\" & cbx2.SelectedItem,"index.html") = False Then
		create_index_file(workspacesfolder & "\" & cbx2.SelectedItem)
	End If
	If codeobjmap.ContainsKey("index.html") Then
		cbx2.SelectedIndex = -1
		xui.MsgboxAsync("An index page of another workspace is already loaded.","Workspace")
		Return
	End If
	get_workspace_files(workspacesfolder & "\" & cbx2.SelectedItem)
	Dim strtxt As String = File.ReadString(workspacesfolder & "\" & cbx2.SelectedItem, "index.html")
	add_website_tabpage("index.html",strtxt,workspacesfolder & "\" & cbx2.SelectedItem)
	cbx2.SelectedIndex = -1
End Sub
Private Sub get_workspace_files(parent As String)
	'Log("parent: " & parent)
	Dim lst As List = File.ListFiles(parent)
	'Log(parent & ": " & lst)
	For i = 0 To lst.Size -1
		Dim f As String = lst.Get(i)
		'Log(f)
		If File.IsDirectory(parent, f) Then
			get_workspace_files(parent & "\" & f)
		Else
			If f.LastIndexOf(".") <> -1 Then
				Dim ext As String = f.SubString(f.LastIndexOf("."))
				If extweb.IndexOf(ext) <> -1 Then
					read_file(parent & "\" & f)
				End If
				If extvb.IndexOf(ext) <> -1 Then
					read_file(parent & "\" & f)
				End If

			End If
		End If
	Next
End Sub
Private Sub remove_workspace_folder
	dirchoose.InitialDirectory = workspacesfolder
	Dim folder As String = dirchoose.Show(B4XPages.GetNativeParent(B4XPages.MainPage))
	'Log(folder)
	If folder = "" Then Return
	delete_workspace_files(folder)
	Dim fname As String = folder.SubString(folder.LastIndexOf("\")+1)
	File.Delete(workspacesfolder,fname)
	xui.MsgboxAsync(fname & " has been removed.","Remove workspace folder")
	B4XPage_Appear
End Sub
Private Sub delete_workspace_files(parent As String)
	Dim lst As List = File.ListFiles(parent)
	'Log(parent & ": " & lst)
	For i = 0 To lst.Size -1
		Dim f As String = lst.Get(i)
		'Log(f)
		If File.IsDirectory(parent, f) Then
			delete_workspace_files(parent & "\" & f)
			File.Delete(parent,f)
		Else
			File.Delete(parent,f)
		End If
	Next
End Sub

Private Sub reload_wvcode(strtab As String)
	If wvcodemap.ContainsKey(strtab) = True Then
		For Each vw As B4XView In panetab.As(B4XView).GetAllViewsRecursive
			If vw.Tag = strtab Then
				Dim txt As String = wvcodemap.Get(strtab)
				Dim ext As String = strtab.SubString(strtab.LastIndexOf("."))
				Dim mode As String
				If extvb.IndexOf(ext) <> -1 Then
					mode = "vb"
				Else
					Select ext
						Case ".js"
							mode = "javascript"
						Case ".php"
							mode = "php"
						Case ".sql"
							mode = "sql"
						Case Else
							mode = "htmlmixed"
					End Select
				End If
				Dim htmlstring As String = hclass.set_htmlpage(pnright,txt,mode,cbx1.SelectedItem)
				wvcode.LoadHtml(htmlstring)
			End If
		Next
	End If
End Sub
Private Sub reload_wvsite(strtab As String)
	If wvsitemap.ContainsKey(strtab) = True Then
		For Each vw As B4XView In panetableft.As(B4XView).GetAllViewsRecursive
			If vw.Tag = strtab Then
				Dim txt As String = wvsitemap.Get(strtab)
				Dim htmlstring As String = hclass.set_htmlpage(pnleft,txt,"","")
				wvsite.LoadHtml(htmlstring)
			End If
		Next
	End If
End Sub
Private Sub panetab_Resize (Width As Double, Height As Double)
	If wvcode.IsInitialized Then
		reload_wvcode(tfpath.text.SubString(tfpath.text.LastIndexOf("\")+1))
	End If
End Sub
Private Sub panetableft_Resize (Width As Double, Height As Double)

End Sub

Private Sub add_code_tabpage(tabname As String, txt As String)
	Dim pg As TabPage = tpnright.LoadLayout("panetab_layout",tabname)
	panetab.LoadLayout("code_layout")
	panetab.Tag = tabname
	CSSUtils.SetBackgroundColor(tfpath, fx.Colors.ARGB(255,213,255,208))
	If tabname.LastIndexOf(".") = -1 Then
		Dim ext As String = ".txt"
	Else
		Dim ext As String = tabname.SubString(tabname.LastIndexOf("."))
	End If
	Dim mode As String
	If extvb.IndexOf(ext) <> -1 Then
		mode = "vb"
	Else
		Select ext
			Case ".js"
				mode = "javascript"
			Case ".php"
				mode = "php"
			Case ".sql"
				mode = "sql"
			Case Else
				mode = "htmlmixed"
		End Select
	End If
	'Log("before: " & mode)
	Dim htmlstring As String = hclass.set_htmlpage(pnright,txt,mode,cbx1.SelectedItem)
	wvcode.LoadHtml(htmlstring)
	wvcode.Tag = pg.Text
	wvcodemap.Put(wvcode.Tag,txt)
	codeobjmap.Put(wvcode.Tag,wvcode)
End Sub
Private Sub add_website_tabpage(tabname As String, txt As String, path As String)
	Dim pg As TabPage = tpnleft.LoadLayout("panetableft_layout",tabname)
	panetableft.LoadLayout("site_layout")
	panetableft.Tag = tabname
	If tabname = "URL" And txt = "" Then
		wvsite.LoadUrl(path)
		Return
	End If
	If txt.Contains("{@ws}") Then txt = txt.Replace("{@ws}","file:///" & workspacesfolder)
	'Log(txt)
	Dim htmlstring As String = hclass.set_htmlpage(pnleft,txt,"","")
	'Log(htmlstring)
	wvsite.LoadHtml(htmlstring)
	wvsite.Tag = pg.Text
	Log(wvsite.Tag)
	wvsitemap.Put(wvsite.Tag,txt)
End Sub
Private Sub wvsite_LocationChanged (Location As String)
	Log(Location)
	If Location.Contains("file:///") Then
		Dim lpath As String = Location.SubString2(Location.IndexOf("///")+3,Location.LastIndexOf("/"))
		Dim lname As String = Location.SubString(Location.LastIndexOf("/")+1)
		If File.Exists(lpath, lname) Then
			Dim strtxt As String = File.ReadString(lpath, lname)
			If strtxt.Contains("{@ws}") Then strtxt = strtxt.Replace("{@ws}","file:///" & workspacesfolder)
			Dim htmlstring As String = hclass.set_htmlpage(pnleft,strtxt,"","")
			wvsite.LoadHtml(htmlstring)
		Else
			xui.MsgboxAsync(Location & " doesn't exists (yet).","File exists.")
		End If
	End If
End Sub
Sub TabsListChanged_Event (MethodName As String, Args() As Object) As Object
	tpnright.RequestFocus
	Dim jo As JavaObject = Args(0)
	jo.RunMethod("next", Null)
	Dim removed As List = jo.RunMethod("getRemoved", Null)	'ignore
	If removed.Size > 0 Then
		Dim tp As TabPage = removed.Get(0)
		wvcodemap.Remove(tp.Text)
		pathsmap.Remove(tp.Text)
		codeobjmap.Remove(tp.Text)
		'Log("removed: " & tp.Text)
	End If
	Return Null
End Sub
Private Sub btnclose_Click
	tpnright.Tabs.Clear
	wvcodemap.Clear
	pathsmap.Clear
	codeobjmap.Clear
End Sub
Private Sub btnsiteclose_Click
	tpnleft.Tabs.Clear
End Sub
Sub LeftTabsListChanged_Event (MethodName As String, Args() As Object) As Object
	tpnleft.RequestFocus
	Dim jo As JavaObject = Args(0)
	jo.RunMethod("next", Null)
	Dim removed As List = jo.RunMethod("getRemoved", Null)	'ignore
	Return Null
End Sub

Private Sub new_file
	add_code_tabpage("New.txt","")
	pathsmap.Put("New.txt",textfilesfolder)
	tfpath.text = " " & textfilesfolder & "\" & "New.txt"
End Sub
Private Sub load_file(filename As String)
	'Log(filename)
	If filename <> "" Then
		fchoose.InitialFileName = filename.SubString(filename.LastIndexOf("\")+1)
		fchoose.InitialDirectory = filename.SubString2(0,filename.LastIndexOf("\"))
	Else
		fchoose.InitialDirectory = xui.DefaultFolder		
	End If
	fchoose.setExtensionFilter("Extensions", Array As String("*.txt","*.html","*.css","*.js", _
								"*.bas","*.b4a","*.b4j","*.json","*.xml","*.php","*.sql"))
	Dim filename As String = fchoose.ShowOpen(B4XPages.GetNativeParent(B4XPages.MainPage))
	If filename = "" Then Return
	read_file(filename)
End Sub
Private Sub read_file(filename As String)
	Dim filepath As String = filename.SubString2(0,filename.LastIndexOf("\"))
	filename = filename.SubString(filename.LastIndexOf("\")+1)
	Dim strtxt As String = File.ReadString(filepath, filename)
	add_code_tabpage(filename,strtxt)
	pathsmap.Put(filename,filepath)
	tfpath.text = " " & filepath & "\" & filename
End Sub
Private Sub save_file
	If panetab.IsInitialized = False Then Return
'	Log("panetab tag: " & panetab.Tag)
	If codeobjmap.ContainsKey(panetab.tag) = False Then Return
'	Log("codeobjmap: " & codeobjmap)
	wvcode = codeobjmap.Get(panetab.tag)
'	Log("wvcode tag: " & wvcode.Tag)
	If wvcode.IsInitialized = False Then Return
	If wvcode.Tag = "" Then Return
	Dim jo As JavaObject = wvcode
	Dim stredit As String = jo.RunMethodJO("getEngine", Null).RunMethod("executeScript", Array("editor.getValue();"))
	wvcodemap.Put(wvcode.Tag,stredit)
	Dim path As String = tfpath.text.Trim
	If path.Contains("New") = False And path <> "" Then
		path = path.SubString2(0,path.LastIndexOf("\"))
	Else
		path = textfilesfolder
	End If
'	Log(path)
	fchoose.InitialDirectory = path
	fchoose.setExtensionFilter("Extensions", Array As String("*.txt","*.html","*.css","*.js", _
								"*.bas","*.b4a","*.b4j","*.json","*.xml","*.php","*.sql"))
	fchoose.InitialFileName = wvcode.Tag
	Dim fname As String = fchoose.ShowSave(B4XPages.GetNativeParent(B4XPages.MainPage))
	If fname = "" Then Return
	Dim filepath As String = fname.SubString2(0,fname.LastIndexOf("\"))
	Dim filename As String = fname.SubString(fname.LastIndexOf("\")+1)
	Dim strtxt As String = wvcodemap.Get(wvcode.Tag)
	'Log(wvcode.Tag)
'	Log("filepath: " & filepath)
'	Log("filename: " & filename)
	File.WriteString(filepath,filename,strtxt)
	wvcodemap.Put(filename,strtxt)
	pathsmap.Put(filename,filepath)
	tfpath.text = " " & filepath & "\" & filename
	B4XPage_Appear
End Sub

Private Sub fill_cbx1		' selection of codemirror themes
	Dim lst As List = Array As String("default","abbott","abcdef","bespin","blackboard","colorforth", _
									  "dracula","eclipse","isotope","lucario","mdn-like","rubyblue")
	cbx1.SetItems(lst)
End Sub
Private Sub cbx1_SelectedIndexChanged (Index As Int)
	If tfpath.IsInitialized Then
		reload_wvcode(wvcode.Tag)
	End If
End Sub

Private Sub btnshow_Click
	If panetab.IsInitialized = False Then Return
'	Log("panetab tag: " & panetab.Tag)
	If codeobjmap.ContainsKey(panetab.tag) = False Then Return
'	Log("codeobjmap: " & codeobjmap)
	wvcode = codeobjmap.Get(panetab.tag)
'	Log("wvcode tag: " & wvcode.Tag)
	If wvcode.IsInitialized Then
		Dim fname As String = wvcode.tag
'		Log("fname: " & fname)	
		Dim ext As String = fname.SubString(fname.LastIndexOf("."))
		If extvb.IndexOf(ext) <> -1 Then
			Return
		End If
		Dim jo As JavaObject = wvcode
		Dim stredit As String = jo.RunMethodJO("getEngine", Null).RunMethod("executeScript", Array("editor.getValue();"))
		wvcodemap.Put(wvcode.Tag,stredit)
		Dim path As String = tfpath.text.Trim
		If path.Contains("New") = False And path <> "" Then
			path = path.SubString2(0,path.LastIndexOf("\"))
		End If
'		Log(path)
		If File.Exists(path,wvcode.tag) = True Then
			Dim filepath As String = path
			Dim filename As String = wvcode.tag
			File.WriteString(filepath,filename,stredit)
			wvcodemap.Put(filename,stredit)
			pathsmap.Put(filename,filepath)
			tfpath.text = " " & filepath & "\" & filename
		Else
			If path.Contains("New") Or path = "" Then
				fchoose.InitialDirectory = textfilesfolder
				fchoose.setExtensionFilter("Website", Array As String("*.txt","*.html","*.css","*.js","*.bas","*.b4a","*.b4j"))
				fchoose.InitialFileName = wvcode.Tag
				Dim fname As String = fchoose.ShowSave(B4XPages.GetNativeParent(B4XPages.MainPage))
				If fname = "" Then Return
'				Log("fname: " & fname)
				Dim filepath As String = fname.SubString2(0,fname.LastIndexOf("\"))
				filename = fname.SubString(fname.LastIndexOf("\")+1)
'				Log("filepath: " & filepath)
'				Log("filename: " & filename)
				File.WriteString(filepath,filename,stredit)
				wvcodemap.Put(filename,stredit)
				pathsmap.Put(filename,filepath)
				tfpath.text = " " & filepath & "\" & filename
			End If
		End If
		add_website_tabpage(wvcode.Tag,wvcodemap.get(wvcode.Tag),filepath)
	End If
End Sub
Private Sub btnsave_Click
	save_file
End Sub
Private Sub btnforward_Click
	If wvsite.IsInitialized Then
		jowv = wvsite
		jowe = jowv.RunMethod("getEngine",Null)
		jowe.RunMethod("executeScript",Array As Object("history.forward()"))
	End If
End Sub
Private Sub btnback_Click
	If wvsite.IsInitialized Then
		jowv = wvsite
		jowe = jowv.RunMethod("getEngine",Null)
		jowe.RunMethod("executeScript",Array As Object("history.back()"))
	End If
End Sub
Private Sub tpnright_TabChanged (SelectedTab As TabPage)
	If SelectedTab.IsInitialized Then
		If panetab.IsInitialized Then
			panetab.Tag = SelectedTab.Text
			'Log(panetab.Tag)
		End If
	End If
End Sub

