﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.8
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private htmlstring As String
End Sub
Public Sub Initialize
	htmlstring = ""
End Sub
Public Sub set_htmlpage(pn As Pane,strtext As String,mode As String,theme As String) As String
	Private sb As StringBuilder
	sb.Initialize
	sb = html_header(sb,theme,mode)
	sb = html_body(sb,strtext,pn,mode,theme)
	sb = html_footer(sb)
	htmlstring = sb.ToString
	Return htmlstring
End Sub
Private Sub html_header(sb As StringBuilder,theme As String,mode As String) As StringBuilder
	sb.Append("<html>")
	sb.Append("<head>")
	sb.Append("<meta name='viewport' content='width=device-width, initial-scale=1'>")
	sb = add_stylesheet(sb,"codemirror.css")
	sb = add_stylesheet(sb,"eclipse.css")
	If theme <> "" And theme <> "default" Then sb = add_stylesheet(sb,theme & ".css")
	sb = add_javascript(sb,"codemirror.js")
	sb = add_javascript(sb,"javascript.js")
	sb = add_javascript(sb,"htmlmixed.js")
	sb = add_javascript(sb,"css.js")
	sb = add_javascript(sb,"clike.js")	'needed for php
	sb = add_javascript(sb,"php.js")
	sb = add_javascript(sb,"vb.js")
	sb = add_javascript(sb,"sql.js")
	sb = add_javascript(sb,"xml.js")
	Return sb
End Sub
Private Sub html_body(sb As StringBuilder, strtext As String,pn As Pane,mode As String,theme As String) As StringBuilder
	'Log("mode argument: " & mode)
	If pn = B4XPages.MainPage.pnright Then
		sb.Append("</head><body style='background-color:#DDDAFF;'>")
		sb.Append("<textarea id='editor'>").Append(strtext).Append("</textarea>").Append(CRLF)
		sb.Append("<script> var editor = CodeMirror.fromTextArea(document.getElementById('editor'), { ").Append(CRLF)
		Select mode
			Case "vb"
				sb.Append("mode:'vb'")
			Case "javascript"
				sb.Append("mode:'javascript'")
			Case "php"
				sb.Append("mode:'application/x-httpd-php'")
			Case "sql"
				sb.Append("mode:'text/x-sql'")
			Case Else
				sb.Append("mode:'htmlmixed'")
		End Select
		sb.Append(", theme:'"& theme & "', lineNumbers:true, lineWrapping:true").Append(CRLF)	', scrollbarStyle:native
		sb.Append(" });").Append(CRLF)
		sb.Append("editor.setSize('").Append("null")
		sb.Append("','").Append("100%").Append("')").Append(CRLF)
'		sb.Append("','").Append(pn.PrefHeight-140).Append("')").Append(CRLF)
		sb.Append("</script>").Append(CRLF)
	Else
		'sb = add_stylesheet(sb,"w3.css")		'use stylesheet from file
		sb.Append("</head><body>")
		sb.Append("<div>").Append(strtext).Append("</div>").Append(CRLF)
	End If
	'Log(sb.ToString)
	Return sb
End Sub
Private Sub html_footer(sb As StringBuilder) As StringBuilder
	sb.Append("</body></html>")
	Return sb
End Sub
private Sub add_stylesheet(sb As StringBuilder, fname As String) As StringBuilder
	Dim css As String = File.ReadString(File.DirAssets,fname)
	sb.Append("<style type='text/css'>").Append(css).Append("</style>").Append(CRLF)
	Return sb
End Sub
private Sub add_javascript(sb As StringBuilder, fname As String) As StringBuilder
	Dim js As String = File.ReadString(File.DirAssets,fname)
	sb.Append("<script>").Append(js).Append("</script>").Append(CRLF)
	Return sb
End Sub
